
[//]: # (the bookshelf LaTeX class)

# The bookshelf LaTeX2ε package

This is the README.md file for the bookshelf LaTeX class v0.8 (2024-01-04)
generated by ClassPack v.1.28 (2024-02-21) on 21 February 2024 at 20:35:52 

## Summary
%% 
The _bookshelf_ package uses _biblatex_ and _biber_ to turn any large BiBTeX bibliography file into a randomly-coloured, randomly-sized shelf of books, with the title and author in a randomly-chosen typeface. The image (converted to JPEG from PDF) can then be used as a background in _Zoom_, _Teams_, _WhatsApp_ etc video calls. It requires a little preliminary work with the supplied script to set up a list of all your fonts, a list of colors, and a list of the BiBTeX entry names in your `.bib` file, but otherwise should work on any modern TeX distribution.

![Image created from the author’s own files](http://latex.silmaril.ie/packages/bookshelf/myshelf.jpg)


## Automated installation
%% 
If this class is distributed from [CTAN](https://ctan.org/pkg/bookshelf), it should be in a zip file which allows it to be installed automatically by the TeX Live Manager (_tlmgr_) and similar automated installers. If you are using automated LaTeX package installation, no further action is required.
%% 
If you are using the TeX Live Manager program manually, you can install this package with the command:


## TDS installation
%% 
This class is also available as a TeX Directory System (TDS) zip file (`.tds.zip`) from [the author’s package site](http://latex.silmaril.ie/packages/bookshelf). This is the standard directory layout for a modern TeX installation which enables the class to be unzipped directly into your Personal TeX Directory without the need to use _tlmgr_.
%% 
If you haven’t yet created a Personal TeX Directory, see [Formatting Information](http://latex.silmaril.ie/formattinginformation/) for details of what one is, and how to create it.

  *  You can install this class on any TDS-compliant personal system (laptop, desktop, workstation, table, smartphone, PDA, etc) by unzipping it straight into your Personal TeX Directory. This will put all the files into the right places, so you can start using them immediately.

  *  On a shared (multiuser) system like a server, the administrator can unzip it into the `$TEXMFLOCAL` directory instead (see below), and run your TeX directory-indexing program (eg _texhash_, _mktexlsr_, etc) so that everyone can use it.

  *  If you are using an old non-TDS-compliant system, or an online system with no TDS access, unzip the files _without their directory structure_ and put them all in your document directory.


## Usage
%% 
Include the line shown below in the Preamble of your LaTeX document; a `\documentclass` line should be at the top; a `\usepackage` command normally goes anywhere in your Preamble:

```LaTeX
\documentclass[options]{bookshelf}
```
%% 
(similarly for other classes or packages). Read the documentation for the options available, if any. The documentation is distributed as a PDF document in the zip file. You can also regenerate it by typesetting the `bookshelf.dtx` file with xelatex (and biber and _makeindex_) in the normal way.


## Bugs and TODO
%% 
No outstanding reported bugs at the time of this version.
%% 
For TODO items, see the PDF documentation.


## Copyright
%% 
The following statement is included in the source code:

     Transformed from bookshelf.xml by ClassPack db2dtx.xsl
     version 1.28 (2024-02-21) on Wednesday 21 February 2024 at 20:35:52
    
     bookshelf.cls is copyright © 2020-2024 by Peter Flynn <peter@silmaril.ie>
    
     This work may be distributed and/or modified under the
     conditions of the LaTeX Project Public License, either
     version 1.3 of this license or (at your option) any later
     version. The latest version of this license is in:
    
         http://www.latex-project.org/lppl.txt
    
     and version 1.3 or later is part of all distributions of
     LaTeX version 2005/12/01 or later.
    
     This work has the LPPL maintenance status ‘maintained’.
     
     The current maintainer of this work is Peter Flynn <peter@silmaril.ie>
    
     This work consists of the files bookshelf.dtx and bookshelf.ins,
     and any other ancillary files listed in the MANIFEST.
    

